package net.openid.conformance.openbanking_brasil.testmodules.phase3.automaticPayments.abstractModule;

import net.openid.conformance.openbanking_brasil.testmodules.phase3.automaticPayments.AbstractAutomaticPaymentsAutomaticPixUnhappyConsentPathTestModule;
import net.openid.conformance.openbanking_brasil.testmodules.support.automaticPayments.createRecurringConfigurationObject.AbstractCreateRecurringConfigurationObject;
import net.openid.conformance.openbanking_brasil.testmodules.support.automaticPayments.createRecurringConfigurationObject.automatic.CreateAutomaticRecurringConfigurationObjectTrimestral;
import net.openid.conformance.openbanking_brasil.testmodules.support.automaticPayments.editConsentBody.editAutomaticRecurringConfigurationObject.EditRecurringPaymentsAutomaticConsentBodyToAddBothFixedAndVariableAmounts;
import net.openid.conformance.openbanking_brasil.testmodules.support.automaticPayments.editConsentBody.editAutomaticRecurringConfigurationObject.EditRecurringPaymentsAutomaticConsentBodyToAddMinHigherThanMax;
import net.openid.conformance.openbanking_brasil.testmodules.support.paymentsv2.ensureErrorResponse.EnsureErrorResponseCodeFieldWasDetalhePagamentoInvalido;

public abstract class AbstractAutomaticPaymentsApiAutomaticPixNegativeConsentTestModule extends AbstractAutomaticPaymentsAutomaticPixUnhappyConsentPathTestModule {

	@Override
	protected void performTestSteps() {
		performTestStep(
			", sending fixedAmount as 1 BRL and maximumVariableAmount as 1 BRL",
			EditRecurringPaymentsAutomaticConsentBodyToAddBothFixedAndVariableAmounts.class,
			EnsureErrorResponseCodeFieldWasDetalhePagamentoInvalido.class
		);

		performTestStep(
			", sending minimumVariableAmount as 1 BRL and maximumVariableAmount as 0.5 BRL",
			EditRecurringPaymentsAutomaticConsentBodyToAddMinHigherThanMax.class,
			EnsureErrorResponseCodeFieldWasDetalhePagamentoInvalido.class
		);
	}

	@Override
	protected AbstractCreateRecurringConfigurationObject consentBodyCondition() {
		return new CreateAutomaticRecurringConfigurationObjectTrimestral();
	}
}
